<template>
    <div class="row">
        <div class="col-12">

            <h2>Gestion des utilisateurs</h2>
        </div>
        <form class="container" v-on:submit.prevent="submit()">
            <div class="row">
                <div class="col-6">
                    <div class="form-group">
                        <label>Nom
                            <span>*</span>
                        </label>
                        <input class="form-control" type="text" name="Lastname" v-model="user.lastname" required>
                    </div>
                </div>

                <div class="col-6">
                    <div class="form-group">
                        <label>Prénom
                            <span>*</span>
                        </label>
                        <input class="form-control" type="text" name="firstname" v-model="user.firstname" required>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-6">
                    <div class="form-group">
                        <label>Login
                            <span>*</span>
                        </label>
                        <input class="form-control" type="text" name="login" v-model="user.username" required>
                    </div>
                </div>
                <div class="col-6">
                    <div class="form-group">
                        <label>Mot de passe</label>
                        <input class="form-control" type="password" name="password" v-model="user.password" :disabled="pwd">
                    </div>
                </div>
            </div>
            <div class="col-12">
                <div class="form-group">
                    <label>Email
                        <span>*</span>
                    </label>
                    <input class="form-control" type="email" name="email" v-model="user.email" required>
                </div>
            </div>
            <div class="row">
                <div class="col-6">
                    <div class="form-group">
                        <label>CJM</label>
                        <input class="form-control" type="number" name="cjm" v-model="user.cjm">
                    </div>
                </div>
                <div class="col-6">
                    <div class="form-group">
                        <label>Trigramme
                            <span>*</span>
                        </label>
                        <input class="form-control" type="text" name="trigramme" v-model="user.trigramme" required>
                    </div>
                </div>
            </div>

            <div class="row">
                <div class="col-6">
                    <div class="form-group">
                        <label>Téléphone</label>
                        <input class="form-control" type="number" name="phone" v-model="user.phone">
                    </div>
                </div>

                <div class="col-6">
                    <div class="form-group">
                        <label>Date d'embauche
                            <span>*</span>
                        </label>
                        <Datepicker input-class="form-control" name="dateEmbauche" v-model="user.dateembauche" :required="true">

                        </Datepicker>

                    </div>
                </div>
            </div>

            <div class="col-12">
                <div class="form-group">
                    <label>Rôle</label>
                    <select class="form-control" type="text" name="role" v-model="user.role">
                        <option value="administrateur">Administrateur</option>
                        <option value="responsable RH">Responsable RH</option>
                        <option value="commercial">Commercial</option>
                        <option value="chef de projet">Chef de projet</option>
                        <option value="développeur">Développeur</option>
                    </select>
                </div>
            </div>
            <div class="col-12">
                <div class="form-group">
                    <label>Agence</label>
                    <select class="form-control" type="text" name="agence" v-model="user.agence">
                        <option value="Paris"> Paris</option>
                        <option value="Toulouse">Toulouse</option>
                    </select>
                </div>
            </div>

            <div class="row">
                <div class="col-12">
                    <div class="form-group">
                        <label>Date dernier BPI
                            <span>*</span>
                        </label>
                        <Datepicker input-class="form-control" type="date" name="dateBpi" v-model="user.datebpi" :required="true"></Datepicker>
                    </div>
                </div>
            </div>

            <div class="row">
                <div class="col-6">
                    <div class="form-group">
                        <label>Date de naissance
                            <span>*</span>
                        </label>
                        <Datepicker input-class="form-control" type="date" name="birthDate" v-model="user.birthdate" :required="true"></Datepicker>
                    </div>
                </div>

                <div class="col-6">
                    <div class="form-group">
                        <label>Lieu de naissance
                            <span>*</span>
                        </label>
                        <input class="form-control" type="text" name="birthPlace" v-model="user.birthplace" required></input>
                    </div>
                </div>
            </div>

            <div class="col-12">
                <div class="form-group">
                    <label>Numéro de sécurité sociale
                        <span>*</span>
                    </label>
                    <input class="form-control" type="number" name="socialNumber" v-model="user.socialnumber" required>
                </div>
            </div>

            <div class="row">
                <div class="col-4">
                    <div class="form-group">
                        <label>Adresse
                            <span>*</span>
                        </label>
                        <input class="form-control" type="text" name="adress" v-model="user.adress" required>
                    </div>
                </div>

                <div class="col-4">
                    <div class="form-group">
                        <label>Code postale
                            <span>*</span>
                        </label>
                        <input class="form-control" type="text" name="zip" v-model="user.zipcode" required>
                    </div>
                </div>

                <div class="col-4">
                    <div class="form-group">
                        <label>Ville
                            <span>*</span>
                        </label>
                        <input class="form-control" type="text" name="town" v-model="user.town" required>
                    </div>
                </div>
            </div>

            <div class="row">
                <div class="col-6">
                    <div class="form-group">
                        <label>Bac plus</label>
                        <input class="form-control" type="text" name="bacplus" v-model="user.bacplus">
                    </div>
                </div>
                <div class="col-6">
                    <div class="form-group">
                        <label>Date début experience</label>
                        <Datepicker input-class="form-control" type="date" name="experiencedate" v-model="user.experiencedate"></Datepicker>
                    </div>
                </div>
            </div>

            <div class="row">
                <div class="col-6">
                    <div class="form-group">
                        <label>Durée période d'essai</label>
                        <input class="form-control" type="number" name="tryperiode" v-model="user.tryperiode">
                    </div>
                </div>

                <div class="col-6">
                    <div class="form-group">
                        <label>Nombre de renouvellement de période d'essai</label>
                        <input class="form-control" type="number" name="numbertryperiode" v-model="user.numbertryperiode">
                    </div>
                </div>
            </div>
            <br>
            <form class="container" enctype="multipart/form-data">
                <div class="form-group">
                    <label>Photo</label>
                    <input class="form-control" type="file" name="file" @change="filesChange($event.target.name, $event.target.files);">
                </div>
            </form>
            <div class="form-group">
                <button class="btn btn-primary" type="submit"> Sauvegarder </button>
                <button class="btn btn-secondary" type="button" v-on:click="retour()"> Retour </button>

            </div>

        </form>

    </div>
</template>

<script>
import Datepicker from 'vuejs-datepicker';
import { upload } from '@/api/upload.service.js';
export default {
    props: [
        "user",
        "pwd"
    ], methods: {
        submit: function() {
            this.$emit("submit");
        },
        retour: function() {
            console.log("hello");
            this.$emit("back");
        },
        save(formData) {
            upload(formData)
                .then(x => {
                    this.user.path = x.data.data.path;
                })
                .catch(err => {
                    console.log(err)
                    alert("Une erreur s'est produite");
                });
        },
        filesChange(fieldName, fileList) {

            const formData = new FormData();
            if (!fileList.length) return;
            Array
                .from(Array(fileList.length).keys())
                .map(x => {
                    formData.append(fieldName, fileList[x], fileList[x].name);
                });

            // save it
            this.save(formData);
        },
    },
    components: {
        Datepicker
    }

}
</script>

<style scoped>
span {
    color: red;
}

h2 {
    font-family: "Vollkorn";
    font-size: 30px;
    text-align: left;
    margin-left: 100px;
}
</style>
